# Test - Δοκιμή
# This file should be stored as UTF8.
# 
# A run through what the RokuUI class can do
#

use strict;
use RokuUI;

#
# If the program terminates abruptly, it can leave its text 
# on the roku display. This is an attempt to trap
# such errors and clean things up
#

for my $int ('INT','QUIT','HUP','TRAP','ABRT','STOP') { 
   $SIG{$int} = 'interrupt';
}  

my $roku = RokuUI->new(host => '192.168.0.11', port => 4444, font => 2);
$roku->open();

# This will be displayed for 3 seconds, and the remote will not work
$roku->msg(y=>-10, text => "this is a large test", font => 3, keygrab=>2, duration=>3);

# This will be displayed for 5 seconds, or until the remote is hit
$roku->msg(text => "this is a small test", font => 1, duration=>5, x=>30, y=>4, keygrab=>1, clear=>1);

#there is another way to clear the screen
$roku->clear();

# And this is a scrolling text
$roku->msg(text => "this is a marquee", mode => 'marquee');
$roku->msg(text => "Μία δοκιμή", encoding=>'utf8');

my $rc;

my $onoff = ($roku->ison) ? 'on' : 'off';

# grabkey=1 captures a button press (the soundbridge doesn't receive it)
$rc = $roku->msg(text => "Your roku is $onoff - press a key on the remote", duration=>5, keygrab=>1);
$roku->clear();
if ($rc) { 
 if ($rc eq 'TIMEOUT') { 
   $roku->msg(text => "Is your remote broken or something?");
 } else { 
   $roku->msg(text => "You pressed ".$rc);
 }
} 

# this call returns immediately, but the control is locked until you close the connection

$roku->msg(text => "Now you can't do a thing...", duration=>0); 

# but things still work....

print $roku->cmd('time');

sleep(5);

$roku->msg(text => "Now, press a key, this time the roku will do it", duration=>10, keygrab=>0); 

$roku->msg(text => "Bye Now!", font => 2, duration=>3, clear=>1);

$roku->close();


sub interrupt {
        exit(@_);
}

END {
  undef $roku;  
}
