#
# Copyright Michael Polymenakos 2007 mpoly@panix.com
#
# Released under the GPL. http://www.gnu.org/licenses/gpl.txt
#

use strict;
use RokuUI;
use XML::DOM;
use LWP::UserAgent;

my ($current,$current2);

my %forecast;

our (%config,%loc_words,%loc_days,@loc_wind,%loc_cond);
require "local";

####################################################################

#
# If the program terminates abruptly, it can leave its text 
# on the roku display. This is an attempt to trap
# such errors and clean things up
#

for my $int ('INT','QUIT','HUP','TRAP','ABRT','STOP') { 
   $SIG{$int} = 'interrupt';
}   

my $display = RokuUI->new(host => $config{rokuip},port => $config{rokuport});

my $last_fetch = 0;

push (@loc_wind,@loc_wind[0]);

while (1) { 

  $display->open || die("Could not connect to Roku Soundbridge");  

  if ($display->ison()) {
    $display->close;
    sleep $config{sec_wait_when_on};
  } else { 
    if ((time()-$last_fetch) > ($config{refetch_data_every} * 60)) { 

      # See http://developer.yahoo.com/weather/
      
      $last_fetch = time();
      my $parser = new XML::DOM::Parser;
      my $feed = $parser->parsefile('http://weather.yahooapis.com/forecastrss?p='.$config{location}.'&u='.$config{temp_scale});

      undef $current;

      $current  = "";
      $current2 = "";
 
      foreach my $item ($feed->getElementsByTagName('yweather:condition')) {
        $current .= $item->getAttribute('temp').$loc_words{'TempScale'}." - ";
        $current .= $loc_cond{$item->getAttribute('code')+0};
        $current =~ s/\(.*\)//;
        last;
      }

      foreach my $item ($feed->getElementsByTagName('yweather:atmosphere')) {
        $current2 .= $loc_words{'Humidity'}.' '.$item->getAttribute('humidity')."%, ";
        last;
      }

      foreach my $item ($feed->getElementsByTagName('yweather:wind')) {      
        my $direction = @loc_wind[int($item->getAttribute('direction')/(360/(@loc_wind - 1))+.50)];    
        $current2 .= $loc_words{'Wind'}." $direction ".$item->getAttribute('speed').$loc_words{'WindSpeed'};
        last;
      }

      undef %forecast;

      my $j = 0;

      foreach my $item ($feed->getElementsByTagName('yweather:forecast')) {
        $forecast{$j} = $loc_days{$item->getAttribute('day')}.": ";
        $forecast{$j} .= $item->getAttribute('low')." ".$loc_words{'To'}." ";
        $forecast{$j} .= $item->getAttribute('high').$loc_words{'TempScale'}.", ";
        $forecast{$j} .= $loc_cond{$item->getAttribute('code')+0};
        $j++;
      }

    }
     
    next if $display->ison();

    $display->msg(encoding=>$config{encoding},font=>2);

    # The Yahoo! Weather attribution must be here, see their Terms of Service
    
    $display->msg(text => "Yahoo! Weather: ".$current, duration=>$config{sec_display_current}, clear=>1, keygrab=>0);
    
    next if $display->ison();
    
    $display->msg(text=>$current2,duration=>$config{sec_display_forecast}, clear=>1, keygrab=>0);

    for my $key (sort keys %forecast) {
      next if $display->ison();
      $display->msg(text => $forecast{$key}, duration=>$config{sec_display_forecast}, clear=>1, keygrab=>0);
    }

    $display->close;
    
    sleep($config{sec_display_normal});
    
  }  
}

sub interrupt {exit(@_)};

END {
  undef $display;  
}
